Make WordPress Core


Ignore:
Timestamp:
03/11/2025 02:17:41 PM (19 months ago)
Author:
TimothyBlynJacobs
Message:

REST API: Fix fatal error when making HEAD requests with _fields filter.

In [59889] the REST API controllers were adjusted to perform less work when responding to HEAD requests. The WP_REST_Response body would now be null, which caused issues with filters that expected the response body to be an array.

This commit sets the response body to be an empty array when preparing the response instead. The body will still be discarded, but this provides better backward comppatibility with code that assumes an array will be used.

See #56481.
Props antonvlasenko, timothyblynjacobs, mamaduka, wildworks.

File:
1 edited

Legend:

Unmodified
Added
Removed
  • trunk/tests/phpunit/tests/rest-api/rest-widget-types-controller.php

    r59899 r59970  
    130130                $response = rest_get_server()->dispatch( $request );
    131131                $this->assertSame( 200, $response->get_status(), 'The response status should be 200.' );
    132                 $this->assertNull( $response->get_data(), 'The server should not generate a body in response to a HEAD request.' );
     132                $this->assertSame( array(), $response->get_data(), 'The server should not generate a body in response to a HEAD request.' );
    133133        }
    134134
    … …  
    228228                        return null;
    229229                }
    230                 $this->assertNull( $response->get_data(), 'The server should not generate a body in response to a HEAD request.' );
     230                $this->assertSame( array(), $response->get_data(), 'The server should not generate a body in response to a HEAD request.' );
    231231        }
    232232
    … …  
    240240                        'GET request'  => array( 'GET' ),
    241241                        'HEAD request' => array( 'HEAD' ),
     242                );
     243        }
     244
     245        /**
     246         * @dataProvider data_head_request_with_specified_fields_returns_success_response
     247         * @ticket 56481
     248         *
     249         * @param string $path The path to test.
     250         */
     251        public function test_head_request_with_specified_fields_returns_success_response( $path ) {
     252                wp_set_current_user( self::$admin_id );
     253                $request = new WP_REST_Request( 'HEAD', $path );
     254                $request->set_param( '_fields', 'id' );
     255                $server   = rest_get_server();
     256                $response = $server->dispatch( $request );
     257                add_filter( 'rest_post_dispatch', 'rest_filter_response_fields', 10, 3 );
     258                $response = apply_filters( 'rest_post_dispatch', $response, $server, $request );
     259                remove_filter( 'rest_post_dispatch', 'rest_filter_response_fields', 10 );
     260
     261                $this->assertSame( 200, $response->get_status(), 'The response status should be 200.' );
     262        }
     263
     264        /**
     265         * Data provider intended to provide paths for testing HEAD requests.
     266         *
     267         * @return array
     268         */
     269        public static function data_head_request_with_specified_fields_returns_success_response() {
     270                return array(
     271                        'get_item request'  => array( '/wp/v2/widget-types/calendar' ),
     272                        'get_items request' => array( '/wp/v2/widget-types' ),
    242273                );
    243274        }
Note: See TracChangeset for help on using the changeset viewer.